package net.wanji.feign.service.common;

import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.databus.bo.CrossIdBO;
import net.wanji.databus.dto.*;
import net.wanji.databus.po.SaveToUtcPO;
import net.wanji.databus.vo.*;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Date;

/**
 * @author duanruiming
 * @date 2023/05/19 15:48
 */
public interface FeignCommon {

    /**
     * 信号机状态
     *
     * @return
     */
    @PostMapping("/signalStatus/runningStatusAlarm")
    JsonViewObject runningStatusAlarm();

    @PostMapping("/signalStatus/runningStatusAlarm")
    JsonViewObject runningStatusAlarm(@RequestParam String crossId);

    @PostMapping("/signalStatus/lightStatus")
    JsonViewObject lightStatus();

    @PostMapping("/signalStatus/lightStatus")
    JsonViewObject lightStatus(@RequestParam String crossId);

    /**
     * 信号机控制
     *
     * @param schemeSendVO
     * @return
     */
    @PostMapping("/controlCommand/schemeSend")
    JsonViewObject schemeSend(@RequestBody SchemeSendVO schemeSendVO);

    @PostMapping("/controlCommand/planSend")
    JsonViewObject planSend(@RequestBody PlanSendVO planSendVO);

    @PostMapping("/controlCommand/scheduleSend")
    JsonViewObject scheduleSend(@RequestBody ScheduleSendVO scheduleSendVO);

    @PostMapping("/controlCommand/phaseTimingSend")
    JsonViewObject phaseTimingSend(@RequestBody PhaseTimingSendVO phaseTimingSendVO);

    @PostMapping("/controlCommand/allRedControl")
    JsonViewObject allRedControl(@RequestBody ControlCommandVO commandVO);

    @PostMapping("/controlCommand/yellowLightControl")
    JsonViewObject yellowLightControl(@RequestBody ControlCommandVO commandVO);

    @PostMapping("/controlCommand/closeLightControl")
    JsonViewObject closeLightControl(@RequestBody ControlCommandVO commandVO);

    @PostMapping("/controlCommand/stepControl")
    JsonViewObject stepControl(@RequestParam String crossCode, @RequestParam Integer command, @RequestParam int stepNum);

    @PostMapping("/controlCommand/recoverSchedule")
    JsonViewObject recoverSchedule(@RequestParam String crossCode);

    @PostMapping("/controlCommand/lockControl")
    JsonViewObject lockControl(@RequestBody LockControlVO lockControlVO);

    @PostMapping("/controlCommand/phaseDiffSend")
    JsonViewObject phaseDiffSend();

    @PostMapping("/controlCommand/delBaseConfig")
    JsonViewObject delBaseConfig(@RequestBody DelBaseConfigVO delBaseConfigVO);

    @PostMapping("/controlCommand/saveToUtc")
    JsonViewObject saveToUtc(@RequestBody SaveToUtcPO saveToUtcPO);

    /**
     * 方案数据-方案信息、相位信息、灯组信息
     */
    @PostMapping("/staticInfo/schemePhaseLights")
    JsonViewObject schemePhaseLights(@RequestBody CrossIdVO crossIdVO);

    @PostMapping("/staticInfo/planSection")
    JsonViewObject planSection(@RequestBody PlanSectionDTO planSectionDTO);

    @PostMapping("/staticInfo/crossSchedules")
    JsonViewObject crossSchedules(@RequestBody CrossSchedulesDTO crossSchedulesDTO);

    @PostMapping("/manufacturer/list")
    JsonViewObject listManufacturerInfo(ManufacturerVO manufacturerPO);

    @PostMapping("/crossInfo/list")
    JsonViewObject listCrossInfo(CrossInfoPageVO crossInfoPageVO);

    @PostMapping("/crossInfo/selectById")
    JsonViewObject selectCrossInfoById(CrossIdBO crossIdBO);

    @PostMapping("/crossInfo/crossInfoById")
    JsonViewObject crossInfoById(CrossIdBO crossIdBO);

    // 查询信号机时间
    @PostMapping("/signalTime")
    JsonViewObject signalTime(@RequestParam String crossId);

    // 信号机校时
    @PostMapping("/signalTiming")
    JsonViewObject signalTiming(@RequestParam String crossCode, @RequestParam Date date);

    // 临时方案
    @PostMapping("/tempScheme")
    JsonViewObject tempScheme(SchemeOptSendVO schemeOptSendVO);

    @PostMapping("/control/findPlanId")
    Integer findPlanId(@RequestParam Date datetime, @RequestParam String dateStr, @RequestParam String crossId);

    // 海信-获取方案号
    @PostMapping("/staticInfo/crossSchemeNo")
    JsonViewObject getSchemeNo(@RequestParam String crossId);

    // 海信-下发临时方案
    @PostMapping("/controlCommand/tempSchemeDetail")
    JsonViewObject tempSchemeDetail(@RequestBody TempSchemeSendVO tempDetailVo);

    // 海信-方案环图请求
    @PostMapping("/staticInfo/crossSchemeRings")
    JsonViewObject crossSchemeRings(@RequestBody CrossSchemeRingsDTO crossSchemeRingsDTO);

    // 海信-延长相位
    @PostMapping("/controlCommand/extendPhase")
    JsonViewObject extendPhase(@RequestBody ExtendPhaseDTO extendPhase);

    // 海信-步进相位
    @PostMapping("/controlCommand/stepingPhase")
    JsonViewObject stepingPhase(@RequestBody StepingPhaseDTO stepingPhaseDTO);

}
